Bug 458022 - kernel: random32: seeding improvement [rhel-4.8]
kernel: random32: seeding improvement [rhel-4.8]
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.8
All Linux
medium Severity medium
: rc
: ---
Assigned To: Vitaly Mayatskikh
Martin Jenner
: ZStream
Depends On: 458016 480137
Blocks: 458023 461304
  Show dependency treegraph
 
Reported: 2008-08-06 02:40 EDT by Eugene Teo (Security Response)
Modified: 2009-05-18 15:34 EDT (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-05-18 15:34:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
port numbers distribution on kernel w/o patch (150.33 KB, application/octet-stream)
2008-09-18 09:02 EDT, Vitaly Mayatskikh
no flags Details
port numbers distribution on kernel with patch (150.33 KB, application/octet-stream)
2008-09-18 09:03 EDT, Vitaly Mayatskikh
no flags Details
backported patch (2.23 KB, patch)
2008-09-18 09:04 EDT, Vitaly Mayatskikh
no flags Details | Diff
test case (generates script for octave + gnuplot) (901 bytes, text/x-csrc)
2008-09-18 09:05 EDT, Vitaly Mayatskikh
no flags Details
port numbers distribution on kernel w/o patch (37.88 KB, image/png)
2008-09-18 09:08 EDT, Vitaly Mayatskikh
no flags Details
port numbers distribution on kernel with patch (37.72 KB, image/png)
2008-09-18 09:08 EDT, Vitaly Mayatskikh
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2009:1024 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 4.8 kernel security and bug fix update 2009-05-18 10:57:26 EDT

  None (edit)
Description Eugene Teo (Security Response) 2008-08-06 02:40:55 EDT
+++ This bug was initially created as a clone of Bug #458016 +++

Description of problem:
Stephen Hemminger wrote a patch to improve random32() seeding.

The rationale is:
   * use u32 consistently
   * no need to do LCG on values from (better) get_random_bytes
   * use more data from get_random_bytes for secondary seeding
   * don't reduce state space on srandom32()
   * enforce state variable initialization restrictions

--- Additional comment from eteo@redhat.com on 2008-08-06 02:18:35 EDT ---

Proposed upstream patch:
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commitdiff;h=697f8d0348a652593d195a13dd1067d9df911a82

--- Additional comment from eteo@redhat.com on 2008-08-06 02:22:51 EDT ---

Created an attachment (id=313529)
Upstream patch for this issue
Comment 1 Eugene Teo (Security Response) 2008-08-26 12:54:58 EDT
It needs the following upstream patch as well:
http://git.kernel.org/?p=linux/kernel/git/torvalds/linux-2.6.git;a=commit;h=61407f80f72970d52d4339f81c6c3cd03f4ca0f0
Comment 2 RHEL Product and Program Management 2008-09-03 09:10:03 EDT
Updating PM score.
Comment 3 RHEL Product and Program Management 2008-09-17 16:26:41 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 4 Vitaly Mayatskikh 2008-09-18 09:01:23 EDT
What does this "random32: seeding improvement" patch improve? See pngs in attachments: 78.0.1 doesn't have this patch, and 78.10.EL.bz458022 has. I don't see much difference...
Comment 5 Vitaly Mayatskikh 2008-09-18 09:02:52 EDT
Created attachment 317070 [details]
port numbers distribution on kernel w/o patch
Comment 6 Vitaly Mayatskikh 2008-09-18 09:03:38 EDT
Created attachment 317071 [details]
port numbers distribution on kernel with patch
Comment 7 Vitaly Mayatskikh 2008-09-18 09:04:20 EDT
Created attachment 317072 [details]
backported patch
Comment 8 Vitaly Mayatskikh 2008-09-18 09:05:14 EDT
Created attachment 317073 [details]
test case (generates script for octave + gnuplot)
Comment 9 Vitaly Mayatskikh 2008-09-18 09:08:10 EDT
Created attachment 317074 [details]
port numbers distribution on kernel w/o patch
Comment 10 Vitaly Mayatskikh 2008-09-18 09:08:33 EDT
Created attachment 317075 [details]
port numbers distribution on kernel with patch
Comment 11 Eugene Teo (Security Response) 2008-09-18 09:21:54 EDT
(In reply to comment #4)
> What does this "random32: seeding improvement" patch improve? See pngs in
> attachments: 78.0.1 doesn't have this patch, and 78.10.EL.bz458022 has. I don't
> see much difference...

This was briefly discussed in our internal kernel mailing list. As spoken in IRC, can you follow-up with Dave wrt your findings? Thanks Vitaly.
Comment 20 Vivek Goyal 2009-04-14 09:47:41 EDT
Committed in 88.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/
Comment 24 errata-xmlrpc 2009-05-18 15:34:29 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1024.html

Note You need to log in before you can comment on or make changes to this bug.